--Sprite RenderTool
--version 0.91 3DStudioMax R4
--by Michael Brempel
--directory:...\ui\macroscripts
--additional files: 	rendertool_24i/16i/24a/16a.bmp (...\ui\discreet\)
--			help.txt; help_batch.txt; help.max

MacroScript Sprite_RenderTool
category:"MAX Script Tools"
--internalcategory:"MAX Script Tools"
tooltip:"Sprite RenderTool"
Icon:#("Rendertool",1)
SilentErrors:(Debug == undefined or Debug != True)

(
-------------------------------------------------------------------
global r_floater
global _batchinfopath
-------------------------------------------------------------------Funktionen
fn selectobject pickedobj =
(
	if (isgroupmember pickedobj == true)and(isopengroupmember pickedobj == false) then	---member of a closed group
	(
		while pickedobj.parent!=undefined do	---get head of the group
		(
			if isopengroupmember pickedobj == true then return pickedobj			
			pickedobj=pickedobj.parent
		)
	)
	else
	(
		return pickedobj
	)
)

fn fixpunktcheck bitmap color=
(
	for a=0 to (bitmap.height-1) do
	(
		pixelcolor=getpixels bitmap [0,a] bitmap.width
		for b=1 to bitmap.width do
		(
			if (pixelcolor[b] as point3)==(color as point3) then
			(
				return true
			)
			b+=1
		)
		a+=1
	)
	return false
)

--fn getbatchdata=
--(
--	print "in function getbatchdata"
--)

fn positioncheck bitmap=
(
	pixelcolor=getpixels bitmap [0,0] bitmap.width
	for b=1 to bitmap.width do
	(
		if (pixelcolor[b] as point3)!=(backgroundcolor as point3) then
		(
			return false
		)
		b+=1
	)
	pixelcolor=getpixels bitmap [0,(bitmap.height-1)] bitmap.width
	for b=1 to bitmap.width do
	(
		if (pixelcolor[b] as point3)!=(backgroundcolor as point3) then
		(
			return false
		)
		b+=1
	)
	for b=1 to (bitmap.height-2) do
	(
		pixelcolor=getpixels bitmap [0,b] 1
		if (pixelcolor[1] as point3)!=(backgroundcolor as point3) then
		(
			return false
		)
		b+=1
	)
	for b=1 to (bitmap.height-2) do
	(
		pixelcolor=getpixels bitmap [(bitmap.width-1),b] 1
		if (pixelcolor[1]as point3)!=(backgroundcolor as point3) then
		(
			return false
		)
		b+=1
	)
	return true
)

fn renderthis direction fn_frame layer ofilename opath otype fn_bitmap1: fn_bitmap2: = --<bitmap><int><time><bool><outputfile><outputpath><outputtype>
(
	rendsavefile=on
	rendstart=fn_frame
	rendend=fn_frame
	rendtimetype=3
	fn_frame=int(fn_frame)
	dollarpos=findstring ofilename "$"
	ofilename=replace ofilename dollarpos 1 (direction as string)
	fn_frame=fn_frame+rendfilenumberbase
	if fn_frame<10 then framestring=("000"+(fn_frame as string))
	else if fn_frame<100 then framestring=("00"+(fn_frame as string))
	else if fn_frame<1000 then framestring=("0"+(fn_frame as string))
	else framestring=(fn_frame as string)
	if layer==false then
	(		
		rendoutputfilename=(opath+ofilename+otype)
		deletefile (opath+ofilename+framestring+otype)
		max quick render
		fn_bitmap1=copy(openbitmap (opath+ofilename+framestring+otype))
		fn_bitmap1.filename=(opath+ofilename+framestring+otype)
		return fn_bitmap1
	)
	else if layer==true then
	(
--		if roll_alias.atool_layer.checked==true then
--		(
			opath=(replace opath opath.count 0 "_layer")		-->MFL
			makedir opath
			ofilename=(replace ofilename dollarpos 0 "_layer")	-->MFL
--		)
		rendoutputfilename=(opath+ofilename+otype)
		--antialiasing=false
		--max quick render
		--fn_bitmap2=copy(openbitmap (opath+ofilename+framestring+otype))
		fn_bitmap2=render antialiasing:false frame:rendstart vfb:false
		fn_bitmap2.filename=(opath+ofilename+framestring+otype)
		return fn_bitmap2
	)
)

fn aliasing a_bitmap aa_bitmap fixcolor invert=	--<aliasbitmap><antialiasedbitmap><color><bool>
(
	for a=0 to (a_bitmap.height-1) do	---compare the images(same imagesize!!!)
	(
		a_color=getpixels a_bitmap [0,a] a_bitmap.width
		aa_color=getpixels aa_bitmap [0,a] aa_bitmap.width
		for b=1 to a_bitmap.width do
		(
			if ((aa_color[b] as point3)!=(backgroundcolor as point3))and((aa_color[b] as point3)!=(fixcolor as point3)) then
			(
				if ((a_color[b] as point3)==(backgroundcolor as point3))and(invert==false) then
				(
					aa_color[b]=backgroundcolor
				)
				else if((a_color[b] as point3)!=(backgroundcolor as point3))and(invert==true) then
				(
					aa_color[b]=backgroundcolor
				)
			)
			b+=1
		)
		setpixels aa_bitmap [0,a] aa_color
		a+=1
	)
	aa_bitmap.filename=a_bitmap.filename
	return aa_bitmap
)

----------------------------------------------------------------------------------------------DistanceTool
rollout roll_distance "Lens/Output Sync"
(
	checkbutton dtool_button "Get Lens" width:60 height:17 align:#left across:2
	button dtool_reset "Reset" width:60 height:17 align:#right enabled:false
	local old_height=renderheight
	local old_width=renderwidth
	local old_lens=0.0
	local old_aspect=1.333

	on dtool_button changed state do
	(
		if dtool_button.checked==true then		----button activated
		(
			if viewport.getcamera()!=undefined then		-----kamerafenster ausgewhlt?
			(
				--messagebox "RenderSceneWindow closed?"
				dtool_reset.enabled=true
				dtool_button.text="Set Output"
				old_lens=(viewport.getcamera()).fov
				old_height=renderheight
				old_width=renderwidth			
				max fov
			)
			else
			(
				messagebox "Select a cameraviewport."
				dtool_button.checked=false
			)
		)	
		else			----button deaktiviert -> berechnung
		(
			max move
			dtool_button.text="Get Lens"
			old_aspect=getrendimageaspect() as float		
			new_height=(old_height as float*(tan(((viewport.getcamera()).fov)/2)/tan(old_lens/2)))
			if (new_height-(new_height as integer))>=0.5 then
			(
				renderheight=(ceil(new_height))as integer
			)
			else renderheight=(floor(new_height))as integer
			if ((new_height*old_aspect)-((new_height*old_aspect)as integer))>=0.5 then renderwidth=(ceil(new_height*old_aspect))as integer
			else renderwidth=(floor(new_height*old_aspect))as integer		
			if ((renderwidth as float/renderheight as float)-old_aspect>0.0009) or ((renderwidth as float/renderheight as float)-old_aspect<-0.0009) then
			(
				dtool_message="New ImageAspectRatio! The difference is "+((renderwidth as float/renderheight as float)-old_aspect) as string
				messagebox dtool_message
			)
		)
	)

	on dtool_reset pressed do
	(
		renderheight=old_height as integer
		renderwidth=old_width
		(viewport.getcamera()).fov=old_lens
		max move
		dtool_button.checked=false
		dtool_reset.enabled=false
	)
)
-------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------ObjectAliaser
rollout roll_alias "ObjectAliasing"
(
	checkbox atool_enable "Enable ObjectAlias" checked:false
	checkbox atool_invert "Invert" checked:false enabled:false
--	checkbox atool_layer "_layer erzeugen" checked:true enabled:false
	pickbutton atool_pickit "AliasObject" width:70 height:17 align:#left enabled:false across:2
	edittext atool_picktext "" text:"AliasObject" width:70 height:17 align:#right enabled:false
	button atool_material "Make AliasMaterial" width:140 height:17 enabled:false

	on atool_material pressed do		---matte-shadowmaterial auf aliasobjekt
	(
		if atool_pickit.object==undefined then messagebox "Please select an object."
		else
		(
			meditmaterials[23]=copy meditmaterials[22]
			meditmaterials[23]=matteshadow()
			atool_pickit.object.material=meditmaterials[23]
		)
	)

	on atool_enable changed true do
	(
		atool_pickit.enabled=true
		atool_invert.enabled=true
		atool_material.enabled=true
--		atool_layer.enabled=true	
	)
	
	on atool_pickit picked a_obj do	atool_picktext.text=a_obj.name
)
-------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------Errorcheck
rollout roll_error "ErrorCheck"
(
	checkbox error_fixenable "Search for fixpoint" checked:false	-->MFL
	colorpicker error_fixcolor "FixpointColor" color:red		-->MFL
	checkbox error_charenable "Characterposition" checked:false	-->MFL
	checkbox error_sound "Errorbeep" checked:false			-->MFL
)
-------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------Batchinfos
rollout roll_batch "BatchInfos"
(
	checkbox batch_enable "Batchrendering" checked:false enabled:false
	button batch_get "Get" width:35 height:17 align:#left across:2
	edittext batch_name "" text:"*.txt" width:105 height:17 align:#right enabled:false
	button batch_info "Help" width:70 height:17 align:#left across:2
	button batch_edit "Edit Batch" width:70 height:17 align:#left enabled:false
	on batch_get pressed do
	(
		_batchinfopath=getopenfilename filename:"*.txt" types:"BatchInfoText(*.txt)|*.txt|All|*.*"
		if _batchinfopath!=undefined then
		(
			batch_name.text=filenamefrompath _batchinfopath
			batch_enable.enabled=true
			batch_edit.enabled=true
			batch_enable.checked=true
		)
	)
	on batch_info pressed do
	(
		messagebox "Dateityp: txt-file\neach line: <outputname> <startframe> <endframe>\nzB: stand$A_.tga 0 8\nto avoid problems specify the filetype in the renderscenewindow\n# deactivates the line\noutputdirectory is in the current maxfiledirectory\nclose RenderSceneWindow!" title:"Batchinfo"
	)
	on batch_edit pressed do
	(
		Shelllaunch _batchinfopath ""
	)
)
-------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------RotationRender
rollout roll_rrender "RotationRenderer"
(
	local rotationobject, outputfile
	
	spinner rrender_directions "Directions: " range:[1,36,8] fieldwidth:40 scale:1 align:#right type:#integer	-->MFL
	pickbutton rrender_pickit "RotationObj." width:70 height:17 align:#left across:2
	edittext rrender_picktext "" text:"RotationObj." width:70 height:17 align:#right enabled:false
	button rrender_properties "Renderproperties" height:17 width:140
	button rrender_renderthis "Render" width:140 height:17
	
	on rrender_pickit picked obj do		------define chosen object bzw closed group -> Aliasobjekt
	(
		rotationobject=selectobject(rrender_pickit.object)
		rrender_picktext.text=rotationobject.name
	)
	
	on rrender_properties pressed do
	(
		print _batchinfopath
		max render scene
	)
	
-----------------------------------------------------------------------------------------------Mainroutine
	on rrender_renderthis pressed do
	(
		startframe=0
		endframe=0
		_render=true
		animbuttonstate=false
		directions=rrender_directions.value
		first_outputfile=rendoutputfilename
		first_startframe=rendstart
		first_endframe=rendend
		first_filenumberbase=rendfilenumberbase
		local _batchstream	
		if roll_batch.batch_enable.checked==true then
		(
			_batchstream=openfile _batchinfopath
			_errorfile=createfile ((getfilenamepath _batchinfopath)+"batchrenderlog.txt")
			format ("Following Errors have been noticed in batchrendering\n(successful renderings can be deactiveted by #)\n\n") to:_errorfile
		)
------------------------------------------------------get renderdata
		while _render do
		(
			if roll_batch.batch_enable.checked==true then	----------------------------------------BATCHDATEN
			(
				if eof _batchstream then exit
				_line=readline _batchstream
				if (findstring _line "#")!=undefined then continue	--commented
				if _line=="" then continue		--only \n
				if _line.count<7 then	--less than 7 chars(X_$.bmp->minimum!)
				(
					format ("Failure: too few chars in outputname in '"+_line+"'\n") to:_errorfile
					continue
				)
				_batchvalues=(filterstring _line " ")
				if (_batchvalues.count!=3) then
				(
					format ("Failure: too few parameters in '"+_line+"'\n") to:_errorfile
					continue
				)
				if((_batchvalues[2] as integer)==undefined)or((_batchvalues[3] as integer)==undefined) then
				(
					format ("Failure: framenumbers are wrong in '"+_line+"'\n") to:_errorfile
					continue
				)
				if(_batchvalues[2] as integer)>(_batchvalues[3] as integer) then
				(
					format ("Failure: Startframe is greater than endframe in '"+_line+"'\n") to:_errorfile
					continue
				)
				----------------------set standardvalues
				rendtimetype=3
				rendstart=(_batchvalues[2] as integer)
				rendend=(_batchvalues[3] as integer)
				rendfilenumberbase=(-rendstart)
				renderdir=(substring _batchvalues[1] 1 (_batchvalues[1].count-6))	-->MFL--dh angabe ist zb walk_$.bmp(-> folder "walk" will be created because of "walk_$.bmp"-6)
				--renderdir="renderfolder"						-->MFL
				print (maxfilepath+renderdir)
				makedir (maxfilepath+renderdir)
				print (maxfilepath+renderdir+"\\"+_batchvalues[1])
				rendoutputfilename=(maxfilepath+renderdir+"\\"+_batchvalues[1])
				rrender_directions.value=directions
			)
			--get outputname and framerange from renderscene
			if rendtimetype==1 then	--get rendertyp (single, range etc)
			(
				startframe=sliderTime
				endframe=sliderTime
			)
			else if rendtimetype==2 then
			(
				startframe=animationrange.start
				endframe=animationrange.end
			)
			else if rendtimetype==3 then
			(
				startframe=rendstart
				endframe=rendend
			)
			else if rendtimetype==4 then
			(
				max render scene
				messagebox "This TimeOutput is still not supported. Please select range or single."					
				exit
			)
			_exit=false
			outputfile=getFilenameFile rendoutputfilename	
			outputpath=getFilenamePath rendoutputfilename
			outputtype=getFilenameType rendoutputfilename
---------------------------------------------------------------------------
--------------------------------------------------------Renderabortmessages
			if (findstring outputfile "$" == undefined)and(roll_batch.batch_enable.checked==true) then
			(
				format ("Failure: No $ in '"+outputfile+"'\n") to:_errorfile
				continue
			)
			else if (findstring outputfile "$" == undefined)and(roll_batch.batch_enable.checked==false) then
			(
				messagebox "No $ for directionnumber found in savefile!" title:"Abort renderprocess"
				max render scene
				exit
			)
			else if rotationobject==undefined then
			(
				messagebox "No rotationobject picked" title:"Abort process"
				exit
			)
			else if (roll_alias.atool_pickit.object==undefined)and(roll_alias.atool_enable.checked==true)then
			(
				messagebox "No aliasobject picked." title:"Abort process"
				exit
			)	

--------------------------------------------------------RENDER
			rotationangle=360/directions
			select rotationobject
			set coordsys world
			for directioncount=0 to (directions-1) do	--outer renderschleife(directions)
			(			
				for frame=startframe to endframe do	--inner renderschleife(frames per direction)
				(
					if roll_alias.atool_enable.checked==false then
					(
						bitmap1=renderthis directioncount frame false outputfile outputpath outputtype
					)
					else
					(
						hide roll_alias.atool_pickit.object
						bitmap1=renderthis directioncount frame false outputfile outputpath outputtype
						unhide roll_alias.atool_pickit.object
						bitmap2=renderthis directioncount frame true outputfile outputpath outputtype
						bitmap2=aliasing bitmap2 bitmap1 roll_error.error_fixcolor.color roll_alias.atool_invert.checked
						display bitmap2
						save bitmap2
						close bitmap2
					)
					if (roll_error.error_fixenable.checked==true)and((fixpunktcheck bitmap1 roll_error.error_fixcolor.color)==false) then	--fixpointcheck
					(
						if roll_batch.batch_enable.checked==true then
						(
							format ("Failure: '"+bitmap1.filename+"': Could not find the fixpoint\n") to:_errorfile
							_exit=true
							exit
						)
						else
						(
							messagebox "Could not find the fixpoint" title:"Failure" beep:roll_error.error_sound.checked
							_exit=true
							exit
						)
					)
					if (roll_error.error_charenable.checked==true)and((positioncheck bitmap1)==false) then	--positioncheck
					(
						if roll_batch.batch_enable.checked==true then
						(
							format ("Failure: '"+bitmap1.filename+"': Object goes out of image\n") to:_errorfile
							_exit=true
							exit
						)
						else
						(
							messagebox "Object goes out of image" title:"Failure" beep:roll_error.error_sound.checked
							_exit=true
							exit
						)
					)
					close bitmap1
					frame+=1
				)--frameforschleife
				if _exit==true then
				(
					rotationangle=rotationangle*directioncount
					rotate rotationobject (angleaxis rotationangle[0,0,1])
					exit
				)
				rotate rotationobject (angleaxis -rotationangle[0,0,1])
				directioncount+=1
			)--directionforschleife	

---------------------------------------------------------------------------------------------
			freescenebitmaps()
			gc()
			if (roll_batch.batch_enable.checked==false) then exit	--batchrendering not activated
		)--renderwhileschleife
		if roll_batch.batch_enable.checked==true then
		(
			close (_batchstream)
			close (_errorfile)
			messagebox "Batchrendering finished.\nSee Batchrenderlog." title:"Hint" beep:roll_error.error_sound.checked
			Shelllaunch ((getfilenamepath _batchinfopath)+"batchrenderlog.txt") ""
		)
		rrender_directions.value=directions
		rendoutputfilename=first_outputfile
		rendstart=first_startframe
		rendend=first_endframe
		rendfilenumberbase=first_filenumberbase
	)--onbuttonpressed
)--renderrollout
-------------------------------------------------------------------
rollout roll_info "Info"
(
	group "Important"
	(
		label l1 "RotationRender:" align:#left
		label l2 "1.Pick rotationobject" align:#left
		label l3 "2.First directionNum=0" align:#left
		label l4 "3.Set a $ in outputfilename" align:#left
		label l41"4. don't use less than 7 chars" align:#left
		label l42"  in the outputfilename!" align:#left
		label l43"  X_$.bmp->minimum!" align:#left
		label l44"5.the $-wildcard should be last" align:#left
		label l45"  or prelast sign." align:#left
		label l46"  X_$.bmp or X$_.bmp" align:#left
		label l5 "6.Close RenderScene-" align:#left
		label l6 "    Window before render!" align:#left
		label l7 ""
		label l8 "Batchrendering:" align:#left
		label l9 "*.txt-file-format:" align:#left
		label l10 "<name> <frame> <frame>" align:#left
		label l11 "Close RendersceneWindow!" align:#left
	)
	group "About"
	(
		label l_1 " Sprite RenderTool v0.91/R4" align:#left
		label l_2 " December 2002" align:#left
		label l_3 " by Michael Brempel" align:#left
		label l_4 " mbrempel@gmx.de" align:#left
	)
)

r_floater=newrolloutfloater "Sprite RenderTool" 190 256
addrollout roll_distance r_floater rolledup:true
addrollout roll_alias r_floater rolledup:true
addrollout roll_error r_floater rolledup:true
addrollout roll_batch r_floater rolledup:true
addrollout roll_rrender r_floater
addrollout roll_info r_floater rolledUp:true
)